package uk.co.his.test.embeddedCompoundKeysSimplified;

import java.io.File;
import java.io.IOException;

import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Id;
import javax.persistence.Persistence;


@Entity
public class EContainer  {
	

	public static EContainer getInstance(EntityManager em) {
		EContainer c = em.find(EContainer.class, "1");
		if (c == null) {
			c = new EContainer();
			em.persist(c);
		}
		return c;
	}

	@Id
	protected String id = "1";

	protected EContainer() { // Empty constructor for JPA
	}

	public void addMapItem(EntityManager em, String key)  {
		ECompoundKeyMapItem item = new ECompoundKeyMapItem();
		item.setCachedKey(key);
		item.setContainer(this);
		item.addSubItem(em, key);
		em.persist(item);
	}	
	
	
	public ECompoundKeyMapItem getItem(EntityManager em, String key) {
		return em.find(ECompoundKeyMapItem.class, new ECompoundKeyMapItem.ECompoundKeyMapItemId(key, id));
	}

	public static enum DemoMode { NO_EMBEDDED_MAINTENANCE, ALL_EMBEDDED_MAINTENANCE, WORKS_MAINTENANCE };
	public static DemoMode DEMO_MODE = DemoMode.ALL_EMBEDDED_MAINTENANCE; 
	
	private static final String odbFile = "C:/development/ObjectDb/objectdb-2.3.0_01/db/TestECPK2.odb";

	private static void purgeObjectDb() throws IOException {
		File file = new File(odbFile);
		if (file.exists()) {
			if (!file.delete()) {
				throw new IOException("Cannot delete " + odbFile);
			}
		}
		file = new File(odbFile + "$");
		if (file.exists()) {
			if (!file.delete()) {
				throw new IOException("Cannot delete " + odbFile + "$");
			}
		}
		System.out.println("Purged DB");
	}

	public static void main(String[] args)  {
		String key = "1";
		try {
			purgeObjectDb();
			
			EntityManagerFactory emf = Persistence.createEntityManagerFactory("TestECPK2_ObjectDbPU");
			EntityManager em = emf.createEntityManager();
			em.getTransaction().begin();
			
			EContainer container = EContainer.getInstance(em);
			container.addMapItem(em, key);
			
			em.getTransaction().commit();
			
			em.getTransaction().begin();
			ECompoundKeyMapItem item = container.getItem(em, key);
			if(item == null) {
				System.out.println("Failiure");
			}
			else {
				System.out.println("Success");
			}
			em.getTransaction().commit();
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
